## polybar 3.7.1

=== CMakeLists.txt ===
#
# Build configuration
#
cmake_minimum_required(VERSION 3.5.0 FATAL_ERROR)
project(polybar CXX)

# Extract version information from version.txt. The first line that looks like
# a version string is used, so the file supports comments
file(STRINGS version.txt version_txt REGEX "^[0-9]+\\.[0-9]+\\.[0-9]+.*$" LIMIT_COUNT 1)

# If we are in a git repo we can get the version information from git describe
execute_process(COMMAND git describe --tags --dirty=-dev
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  RESULT_VARIABLE git_result
  OUTPUT_VARIABLE git_describe
  OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_QUIET)

if(git_result EQUAL "0")
  set(APP_VERSION "${git_describe}")
else()
  message(STATUS "Could not detect version with git, falling back to built-in version information.")
  set(APP_VERSION "${version_txt}")
endif()

# Set the default installation prefix to /usr
# Otherwise the default value is /usr/local which causes the default config
# file to be installed to /usr/local/etc, with /usr, cmake has special handling
# for this.
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Project-default installation prefix" FORCE)
endif()

list(APPEND CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/common
  ${PROJECT_SOURCE_DIR}/cmake/modules)

include(GNUInstallDirs)
include(utils)
include(01-core)
include(02-opts)
include(04-targets)

if(BUILD_DOC)
  add_subdirectory(doc)
endif()

if (BUILD_SHELL)
  add_subdirectory(contrib/bash)
  add_subdirectory(contrib/zsh)
endif()

# Setup everything that uses a C++ compiler (polybar, polybar-msg, tests)
if(HAS_CXX_COMPILATION)
  include(cxx)
  if(BUILD_LIBPOLY)
    include(libpoly)
    add_subdirectory(lib)
  endif()
  add_subdirectory(include)
  add_subdirectory(src bin)
endif()

# We need to enable testing in the root folder so that 'ctest' and 'make test'
# can be run in the build directory
if(BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

if(BUILD_CONFIG)
  install(FILES ${CMAKE_SOURCE_DIR}/doc/config.ini
    DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/${PROJECT_NAME}
    COMPONENT config)
endif()

include(05-summary)

=== doc/requirements.txt ===
# Installing these packages is only really needed on readthedocs, building
# locally works as long as sphinx is installed.
# For local development, you may want to install some of these though.
sphinx~=7.2.6
sphinx-rtd-theme~=2.0.0rc2
sphinx-notfound-page~=1.0.0
readthedocs-sphinx-search~=0.3.1

=== contrib/bash/CMakeLists.txt ===
#
# Bash completion template
#
install(FILES polybar
  DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
  COMPONENT tools)

=== lib/xpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0 FATAL_ERROR)
project(xpp)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

#
# Process dependencies
#
find_package(PkgConfig)
pkg_check_modules(XCBPROTO REQUIRED xcb-proto)

# Store the location of the proto xml files inside XCBPROTO_XCBINCLUDEDIR
pkg_get_variable(XCBPROTO_XCBINCLUDEDIR xcb-proto xcbincludedir)

# Search for a python interpreter, if the user didn't specify any
if(NOT PYTHON_EXECUTABLE)
  if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
    find_package(PythonInterp 3.5 REQUIRED)
  else()
    find_package(Python3 REQUIRED COMPONENTS Interpreter)
    if(Python3_FOUND)
      set(PYTHON_EXECUTABLE "${Python3_EXECUTABLE}")
    endif()
  endif()
endif()

if(NOT PYTHON_EXECUTABLE)
  message(FATAL_ERROR "Missing PYTHON_EXECUTABLE")
endif()

find_package(XCB REQUIRED XCB ICCCM EWMH UTIL IMAGE)

set(GEN_SRC "${CMAKE_CURRENT_BINARY_DIR}/generated-sources")

set(XPP_INCLUDE_DIRS
  ${PROJECT_SOURCE_DIR}/include
  ${GEN_SRC}/include
  ${XCB_XCB_INCLUDE_DIR}
  ${XCB_EWMH_INCLUDE_DIR}
  ${XCB_ICCCM_INCLUDE_DIR}
  ${XCB_UTIL_INCLUDE_DIR}
  ${XCB_IMAGE_INCLUDE_DIR})
set(XPP_LIBRARIES
  ${XCB_XCB_LIBRARY}
  ${XCB_EWMH_LIBRARY}
  ${XCB_ICCCM_LIBRARY}
  ${XCB_UTIL_LIBRARY}
  ${XCB_IMAGE_LIBRARY})

#
# Loop through a hardcoded list of python executables to locate the python module "xcbgen"
#
# TODO drop python2 once ubuntu and debian ship python3-xcbgen in their
# maintained distros
foreach(CURRENT_EXECUTABLE ${PYTHON_EXECUTABLE} python3 python python2 python2.7)
  message(STATUS "Searching for xcbgen with " ${CURRENT_EXECUTABLE})

  execute_process(COMMAND "${CURRENT_EXECUTABLE}" "-c"
    "import re,xcbgen;print(re.compile('/xcbgen/__init__.py.*').sub('',xcbgen.__file__))"
    RESULT_VARIABLE _xcbgen_status
    OUTPUT_VARIABLE _xcbgen_location
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

  # When a shell script returns successfully its return code is 0
  if(_xcbgen_status EQUAL 0)
    set(PYTHON_XCBGEN "${_xcbgen_location}" CACHE STRING "Location of python module: xcbgen ")
    message(STATUS "Found xcbgen in " ${PYTHON_XCBGEN})
    break()
  endif()

endforeach(CURRENT_EXECUTABLE)

if(NOT PYTHON_XCBGEN)
  message(FATAL_ERROR "Missing required python module: xcbgen")
endif()

#
# Include XCB libs depending on what protos we build
#
if(NOT XCB_PROTOS)
  set(XCB_PROTOS
    "bigreq"
    "composite"
    "damage"
    "dpms"
    "dri2"
    "dri3"
    "glx"
    "present"
    "randr"
    "record"
    "render"
    "res"
    "screensaver"
    "shape"
    "shm"
    "sync"
    "xc_misc"
    "xevie"
    "xf86dri"
    "xfixes"
    "xinerama"
    "xinput"
    "xkb"
    "xprint"
    "xproto"
    "xselinux"
    "xtest"
    "xv"
    "xvmc")
endif()

if("randr" IN_LIST XCB_PROTOS)
  find_package(XCB REQUIRED RANDR)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_RANDR_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_RANDR_LIBRARY})
endif()
if("render" IN_LIST XCB_PROTOS)
  find_package(XCB REQUIRED RENDER)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_RENDER_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_RENDER_LIBRARY})
endif()
if("damage" IN_LIST XCB_PROTOS)
  find_package(XCB REQUIRED DAMAGE)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_DAMAGE_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_DAMAGE_LIBRARY})
endif()
if("sync" IN_LIST XCB_PROTOS)
  find_package(XCB REQUIRED SYNC)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_SYNC_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_SYNC_LIBRARY})
endif()
if("composite" IN_LIST XCB_PROTOS)
  find_package(XCB REQUIRED COMPOSITE)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_COMPOSITE_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_COMPOSITE_LIBRARY})
endif()
if("xkb" IN_LIST XCB_PROTOS)
  find_package(XCB REQUIRED XKB)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_XKB_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_XKB_LIBRARY})
endif()

set(PROTO_LIST)

file(GLOB PROTO_LIST_RAW RELATIVE ${XCBPROTO_XCBINCLUDEDIR} ${XCBPROTO_XCBINCLUDEDIR}/*.xml)

#
# Filter glob
#
foreach(PROTO_RAW ${PROTO_LIST_RAW})
  string(REGEX REPLACE "(^xf86vidmode.xml|^ge.xml|.xml)\$" "" PROTO ${PROTO_RAW})
  if(PROTO AND "${PROTO}" IN_LIST XCB_PROTOS)
    message(STATUS "${PROJECT_NAME}: including xcb proto ${PROTO_RAW}")
    set(PROTO_LIST ${PROTO_LIST} ${PROTO})
  endif()
endforeach(PROTO_RAW)

#
# Add commands
#
set(PROTO_HEADER_DIR "${GEN_SRC}/include/xpp/proto")
file(MAKE_DIRECTORY ${PROTO_HEADER_DIR})
set(PROTO_HEADER_FILES "")
foreach(PROTO ${PROTO_LIST})
  string(REGEX REPLACE "proto\$" "" PROTO_OUTPUT ${PROTO})
  set(OUTPUT_FILE ${PROTO_HEADER_DIR}/${PROTO_OUTPUT}.hpp)
  add_custom_command(
    OUTPUT ${OUTPUT_FILE}
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/generators/cpp_client.py -p "${PYTHON_XCBGEN}"
    ${XCBPROTO_XCBINCLUDEDIR}/${PROTO}.xml > ${OUTPUT_FILE})
  list(APPEND PROTO_HEADER_FILES ${OUTPUT_FILE})
endforeach(PROTO)

#
# Create project lib and commands
#
file(GLOB_RECURSE HEADER_FILES ${PROJECT_SOURCE_DIR}/include/*.hpp)
add_library(${PROJECT_NAME} STATIC ${HEADER_FILES} ${PROTO_HEADER_FILES})

target_include_directories(${PROJECT_NAME} PUBLIC ${XPP_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PRIVATE ${XPP_LIBRARIES})

target_compile_options(${PROJECT_NAME} PRIVATE -std=c++14 -Wall -Wpedantic)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Debug>:-g3 -DDEBUG>)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Release>:-O3 -Wno-unused-variable>)
target_compile_options(${PROJECT_NAME} PUBLIC ${XCB_DEFINITIONS})

set_target_properties(${PROJECT_NAME} PROPERTIES LINKER_LANGUAGE CXX)

#
# Export lists to the parent scope if there are any
#
get_directory_property(HAS_PARENT PARENT_DIRECTORY)

if(HAS_PARENT)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} PARENT_SCOPE)
  set(XPP_LIBRARIES ${PROJECT_NAME} PARENT_SCOPE)
endif()

=== lib/xpp/src/tests/Makefile ===
include ../../include/flags.makefile

# CXX=clang
CXXFLAGS+=-g
# CXXFLAGS+=-Wextra
# CXXFLAGS+=-ftime-report

CPPSRCS=event.cpp \
        requests.cpp \
        iterator.cpp

all: ${CPPSRCS}

${CPPSRCS}:
	${CXX} ${LDFLAGS} ${CXXFLAGS} -o $(@:%.cpp=%) $@

xlib-test: xlib-test.cpp
	${CXX} $(shell pkg-config --libs --cflags x11 xrandr) -o $@ $<

version:

clean:
	rm -f ${CPPSRCS:%.cpp=%}

.PHONY: ${CPPSRCS} clean

=== debian/changelog ===
polybar (3.7.1-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:20:22 +1100

polybar (3.7.1-1build2) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:56:36 +0000

polybar (3.7.1-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:00:10 +0000

polybar (3.7.1-1) unstable; urgency=medium

  * New upstream version 3.7.1

 -- Samuel Henrique <samueloph@debian.org>  Fri, 22 Dec 2023 12:41:40 -0300

polybar (3.7.0-1) unstable; urgency=medium

  * New upstream version 3.7.0
  * Bump Standards-Version to 4.6.2
  * d/control: Rename build-dep libxcb-util0-dev => libxcb-util-dev

 -- Samuel Henrique <samueloph@debian.org>  Mon, 06 Nov 2023 09:36:52 +0000

=== debian/control ===
Source: polybar
Section: x11
Priority: optional
Homepage: https://polybar.github.io/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Samuel Henrique <samueloph@debian.org>
Uploaders: Utkarsh Gupta <utkarsh@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               i3-wm,
               libasound2-dev,
               libcairo2-dev,
               libcurl4-openssl-dev,
               libjsoncpp-dev,
               libmpdclient-dev,
               libnl-genl-3-dev,
               libpulse-dev,
               libuv1-dev,
               libxcb-composite0-dev,
               libxcb-cursor-dev,
               libxcb-damage0-dev,
               libxcb-ewmh-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-randr0-dev,
               libxcb-render0-dev,
               libxcb-sync-dev,
               libxcb-util-dev,
               libxcb-xkb-dev,
               libxcb-xrm-dev,
               pkg-config,
               python3-sphinx,
               python3-xcbgen,
               xcb-proto
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/polybar
Vcs-Git: https://salsa.debian.org/debian/polybar.git

Package: polybar
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Fast and easy-to-use tool for creating status bars
 Polybar aims to help users build beautiful and highly customizable status bars
 for their desktop environment, without the need of having a black belt in
 shell scripting.

## polybar 3.7.2

=== doc/requirements.txt ===
--- 
+++ 
@@ -4,4 +4,4 @@
 sphinx~=7.2.6
 sphinx-rtd-theme~=2.0.0rc2
 sphinx-notfound-page~=1.0.0
-readthedocs-sphinx-search~=0.3.1
+readthedocs-sphinx-search~=0.3.2

=== lib/CMakeLists.txt ===
#
# Configure libs
#

# Library: xpp {{{

set(XCB_PROTOS xproto)

list(APPEND XCB_PROTOS randr)
list(APPEND XCB_PROTOS composite)
if(WITH_XKB)
  list(APPEND XCB_PROTOS xkb)
endif()

add_subdirectory(xpp)
if(NOT TARGET xpp)
  message(FATAL_ERROR "Target xpp not generated")
else()
  get_target_property(_xpp_includes xpp INCLUDE_DIRECTORIES)
  set_target_properties(xpp PROPERTIES INCLUDE_DIRECTORIES "")
  target_include_directories(xpp SYSTEM PUBLIC ${_xpp_includes})
endif()

# }}}
# Library: i3ipcpp {{{

if(ENABLE_I3)
  add_subdirectory(i3ipcpp)
  if(NOT TARGET i3ipc++)
    message(FATAL_ERROR "Target i3ipcpp not generated")
  else()
    get_target_property(_i3ipcpp_includes i3ipc++ INCLUDE_DIRECTORIES)
    set_target_properties(i3ipc++ PROPERTIES INCLUDE_DIRECTORIES "")
    target_include_directories(i3ipc++ SYSTEM PUBLIC ${_i3ipcpp_includes})
  endif()
endif()

# }}}

=== src/CMakeLists.txt ===
#
# Configure src
#

get_include_dirs(includes_dir)
get_sources_dirs(src_dir)

# Source tree {{{

set(ALSA_SOURCES
  ${src_dir}/adapters/alsa/control.cpp
  ${src_dir}/adapters/alsa/mixer.cpp
  ${src_dir}/modules/alsa.cpp
  )

set(GITHUB_SOURCES ${src_dir}/modules/github.cpp ${src_dir}/utils/http.cpp)

set(I3_SOURCES
  ${src_dir}/modules/i3.cpp
  ${src_dir}/utils/i3.cpp
  )

set(MPD_SOURCES
  ${src_dir}/adapters/mpd.cpp
  ${src_dir}/modules/mpd.cpp
  )

set(NETWORK_SOURCES
  ${src_dir}/adapters/net.cpp
  ${src_dir}/modules/network.cpp
  $<IF:$<BOOL:${WITH_LIBNL}>,${src_dir}/adapters/net_nl.cpp,${src_dir}/adapters/net_iw.cpp>
  )

set(PULSEAUDIO_SOURCES
  ${src_dir}/adapters/pulseaudio.cpp
  ${src_dir}/modules/pulseaudio.cpp
  )

set(XCURSOR_SOURCES ${src_dir}/x11/cursor.cpp)

set(XKB_SOURCES
  ${src_dir}/modules/xkeyboard.cpp
  ${src_dir}/x11/extensions/xkb.cpp
  )

set(XRM_SOURCES ${src_dir}/x11/xresources.cpp)

configure_file(
  ${CMAKE_CURRENT_LIST_DIR}/settings.cpp.cmake
  ${CMAKE_BINARY_DIR}/generated-sources/settings.cpp
  ESCAPE_QUOTES)

set(POLY_SOURCES
  ${CMAKE_BINARY_DIR}/generated-sources/settings.cpp

  ${src_dir}/adapters/script_runner.cpp

  ${src_dir}/cairo/utils.cpp

  ${src_dir}/components/bar.cpp
  ${src_dir}/components/builder.cpp
  ${src_dir}/components/command_line.cpp
  ${src_dir}/components/config.cpp
  ${src_dir}/components/config_parser.cpp
  ${src_dir}/components/controller.cpp
  ${src_dir}/components/logger.cpp
  ${src_dir}/components/renderer.cpp
  ${src_dir}/components/screen.cpp
  ${src_dir}/components/eventloop.cpp

  ${src_dir}/drawtypes/animation.cpp
  ${src_dir}/drawtypes/iconset.cpp
  ${src_dir}/drawtypes/layouticonset.cpp
  ${src_dir}/drawtypes/label.cpp
  ${src_dir}/drawtypes/progressbar.cpp
  ${src_dir}/drawtypes/ramp.cpp

  ${src_dir}/events/signal_emitter.cpp
  ${src_dir}/events/signal_receiver.cpp

  ${src_dir}/ipc/ipc.cpp
  ${src_dir}/ipc/decoder.cpp
  ${src_dir}/ipc/encoder.cpp
  ${src_dir}/ipc/util.cpp

  ${src_dir}/modules/backlight.cpp
  ${src_dir}/modules/battery.cpp
  ${src_dir}/modules/bspwm.cpp
  ${src_dir}/modules/counter.cpp
  ${src_dir}/modules/cpu.cpp
  ${src_dir}/modules/date.cpp
  ${src_dir}/modules/fs.cpp
  ${src_dir}/modules/ipc.cpp
  ${src_dir}/modules/memory.cpp
  ${src_dir}/modules/menu.cpp
  ${src_dir}/modules/meta/base.cpp
  ${src_dir}/modules/meta/factory.cpp
  ${src_dir}/modules/script.cpp
  ${src_dir}/modules/temperature.cpp
  ${src_dir}/modules/text.cpp
  ${src_dir}/modules/xbacklight.cpp
  ${src_dir}/modules/xwindow.cpp
  ${src_dir}/modules/xworkspaces.cpp
  ${src_dir}/modules/tray.cpp


  ${src_dir}/tags/action_context.cpp
  ${src_dir}/tags/context.cpp
  ${src_dir}/tags/dispatch.cpp
  ${src_dir}/tags/parser.cpp

  ${src_dir}/utils/actions.cpp
  ${src_dir}/utils/action_router.cpp
  ${src_dir}/utils/bspwm.cpp
  ${src_dir}/utils/color.cpp
  ${src_dir}/utils/command.cpp
  ${src_dir}/utils/concurrency.cpp
  ${src_dir}/utils/env.cpp
  ${src_dir}/utils/file.cpp
  ${src_dir}/utils/inotify.cpp
  ${src_dir}/utils/io.cpp
  ${src_dir}/utils/process.cpp
  ${src_dir}/utils/restack.cpp
  ${src_dir}/utils/socket.cpp
  ${src_dir}/utils/string.cpp
  ${src_dir}/utils/units.cpp

  ${src_dir}/x11/atoms.cpp
  ${src_dir}/x11/background_manager.cpp
  ${src_dir}/x11/connection.cpp
  ${src_dir}/x11/ewmh.cpp
  ${src_dir}/x11/extensions/composite.cpp
  ${src_dir}/x11/extensions/randr.cpp
  ${src_dir}/x11/icccm.cpp
  ${src_dir}/x11/registry.cpp
  ${src_dir}/x11/legacy_tray_manager.cpp
  ${src_dir}/x11/tray_client.cpp
  ${src_dir}/x11/tray_manager.cpp
  ${src_dir}/x11/window.cpp
  ${src_dir}/x11/winspec.cpp
  ${src_dir}/x11/xembed.cpp

  $<$<BOOL:${ENABLE_ALSA}>:${ALSA_SOURCES}>
  $<$<BOOL:${ENABLE_CURL}>:${GITHUB_SOURCES}>
  $<$<BOOL:${ENABLE_I3}>:${I3_SOURCES}>
  $<$<BOOL:${ENABLE_MPD}>:${MPD_SOURCES}>
  $<$<BOOL:${ENABLE_NETWORK}>:${NETWORK_SOURCES}>
  $<$<BOOL:${ENABLE_PULSEAUDIO}>:${PULSEAUDIO_SOURCES}>
  $<$<BOOL:${WITH_XCURSOR}>:${XCURSOR_SOURCES}>
  $<$<BOOL:${WITH_XKB}>:${XKB_SOURCES}>
  $<$<BOOL:${WITH_XRM}>:${XRM_SOURCES}>
  )

# }}}

# Target poly {{{
add_library(poly STATIC EXCLUDE_FROM_ALL ${POLY_SOURCES})
target_include_directories(poly PUBLIC ${includes_dir})
target_link_libraries(poly PUBLIC
  Threads::Threads
  Cairo::CairoFC
  xpp
  LibUV::LibUV
  )

if (TARGET i3ipc++)
  target_link_libraries(poly PUBLIC i3ipc++)
endif()

if (TARGET ALSA::ALSA)
  target_link_libraries(poly PUBLIC ALSA::ALSA)
endif()

if (TARGET CURL::libcurl)
  target_link_libraries(poly PUBLIC CURL::libcurl)
endif()

if (TARGET LibMPDClient::LibMPDClient)
  target_link_libraries(poly PUBLIC LibMPDClient::LibMPDClient)
endif()

if (TARGET LibNlGenl3::LibNlGenl3)
  target_link_libraries(poly PUBLIC LibNlGenl3::LibNlGenl3)
endif()

if (TARGET Libiw::Libiw)
  target_link_libraries(poly PUBLIC Libiw::Libiw)
endif()

if (TARGET LibPulse::LibPulse)
  target_link_libraries(poly PUBLIC LibPulse::LibPulse)
endif()

if (TARGET Xcb::RANDR)
  target_link_libraries(poly PUBLIC Xcb::RANDR)
endif()

if (TARGET Xcb::COMPOSITE)
  target_link_libraries(poly PUBLIC Xcb::COMPOSITE)
endif()

if (TARGET Xcb::XKB)
  target_link_libraries(poly PUBLIC Xcb::XKB)
endif()

if (TARGET Xcb::CURSOR)
  target_link_libraries(poly PUBLIC Xcb::CURSOR)
endif()

if (TARGET Xcb::XRM)
  target_link_libraries(poly PUBLIC Xcb::XRM)
endif()

if (TARGET LibInotify::LibInotify)
  target_link_libraries(poly PUBLIC LibInotify::LibInotify)
endif()

target_compile_options(poly PUBLIC ${cxx_flags})
set_target_properties(poly PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/libs)
# }}}

# Target: polybar {{{
if(BUILD_POLYBAR)
  add_executable(polybar main.cpp)
  target_link_libraries(polybar poly)
  target_compile_options(polybar PUBLIC ${cxx_flags})
  set_target_properties(polybar PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

  install(TARGETS polybar
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT runtime)
endif()
# }}}

# Target: polybar-msg {{{
if(BUILD_POLYBAR_MSG)
  add_executable(polybar-msg polybar-msg.cpp)
  target_link_libraries(polybar-msg poly)
  target_include_directories(polybar-msg PRIVATE ${includes_dir})
  target_compile_options(polybar-msg PUBLIC ${cxx_flags})

  install(TARGETS polybar-msg
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT runtime)
endif()
# }}}

=== tests/CMakeLists.txt ===
# Download and unpack googletest at configure time {{{
configure_file(
  CMakeLists.txt.in
  ${CMAKE_BINARY_DIR}/googletest-download/CMakeLists.txt
  )
execute_process( COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download)

if(result)
  message(FATAL_ERROR "CMake step for googletest failed: ${result}")
endif()

execute_process(COMMAND ${CMAKE_COMMAND} --build .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download )

if(result)
  message(FATAL_ERROR "Build step for googletest failed: ${result}")
endif()

# Add googletest directly to our build. This defines
# the gtest, gtest_main, gmock and gmock_main targets.
add_subdirectory(${CMAKE_BINARY_DIR}/googletest-src
                 ${CMAKE_BINARY_DIR}/googletest-build
                 EXCLUDE_FROM_ALL)

# }}}

# Compile all unit tests with 'make all_unit_tests'
add_custom_target(all_unit_tests
    COMMENT "Building all unit test")

function(add_unit_test source_file)
  string(REPLACE "/" "_" testname ${source_file})
  set(name "unit_test.${testname}")

  add_executable(${name} unit_tests/${source_file}.cpp)
  get_include_dirs(includes_dir)
  target_include_directories(${name} PRIVATE ${includes_dir} ${CMAKE_CURRENT_LIST_DIR})

  # Link against gmock (this automatically links against gtest)
  target_link_libraries(${name} poly gmock_main)
  add_test(NAME ${name} COMMAND ${name})

  add_dependencies(all_unit_tests ${name})
endfunction()

add_unit_test(utils/actions)
add_unit_test(utils/action_router)
add_unit_test(utils/color)
add_unit_test(utils/command)
add_unit_test(utils/env)
add_unit_test(utils/math)
add_unit_test(utils/scope)
add_unit_test(utils/string)
add_unit_test(utils/file)
add_unit_test(utils/process)
add_unit_test(utils/units)
add_unit_test(components/builder)
add_unit_test(components/command_line)
add_unit_test(components/config_parser)
add_unit_test(drawtypes/label)
add_unit_test(drawtypes/ramp)
add_unit_test(drawtypes/iconset)
add_unit_test(drawtypes/layouticonset)
add_unit_test(ipc/decoder)
add_unit_test(ipc/encoder)
add_unit_test(ipc/util)
add_unit_test(tags/parser)
add_unit_test(tags/dispatch)
add_unit_test(tags/action_context)

# Run make check to build and run all unit tests
add_custom_target(check
  COMMAND GTEST_COLOR=1 ctest --output-on-failure
  DEPENDS all_unit_tests
  )

=== lib/i3ipcpp/CMakeLists.txt ===
# Project setup

cmake_minimum_required(VERSION 3.5.0 FATAL_ERROR)
project(i3ipc++ CXX)

option(WITH_LOGGING "Build with log support" OFF)
option(WITH_TESTS "Build unit tests executables" OFF)
option(BUILD_EXAMPLES "Build example executables" OFF)

add_library(${PROJECT_NAME} STATIC
  ${PROJECT_SOURCE_DIR}/3rd/auss/include/auss.hpp
  ${PROJECT_SOURCE_DIR}/include/i3ipc++/ipc.hpp
  ${PROJECT_SOURCE_DIR}/include/i3ipc++/ipc-util.hpp
  ${PROJECT_SOURCE_DIR}/src/ipc.cpp
  ${PROJECT_SOURCE_DIR}/src/ipc-util.cpp)

target_include_directories(${PROJECT_NAME} PUBLIC ${PROJECT_SOURCE_DIR}/3rd/auss/include)
target_include_directories(${PROJECT_NAME} PUBLIC ${PROJECT_SOURCE_DIR}/include)

target_compile_options(${PROJECT_NAME} PRIVATE -std=c++11 -Wall -Wextra -Wno-unused-parameter -Wno-deprecated-declarations)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Debug>:-g3 -DDEBUG>)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Release>:-O2>)

# External library: jsoncpp-1.7.7 {{{

find_package(PkgConfig)
pkg_check_modules(JSONCPP REQUIRED jsoncpp)

target_link_libraries(${PROJECT_NAME} PUBLIC ${JSONCPP_LIBRARIES})
target_include_directories(${PROJECT_NAME} PUBLIC ${JSONCPP_INCLUDEDIR})

# }}}
# Export lists to the parent scope if there are any {{{

get_directory_property(HAS_PARENT PARENT_DIRECTORY)
if(HAS_PARENT)
  set(I3IPCPP_LIBRARIES ${PROJECT_NAME} PARENT_SCOPE)
  set(I3IPCPP_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/include ${JSONCPP_INCLUDEDIR} PARENT_SCOPE)
endif()

# }}}
# Build examples if the option was given {{{

if(BUILD_EXAMPLES)
  add_subdirectory("${PROJECT_SOURCE_DIR}/examples")
endif()

# }}}
# Build cpp tests if the option was given {{{

if(WITH_TESTS)
  find_package(CxxTest)
  if(CXXTEST_FOUND)
    include_directories(${CXXTEST_INCLUDE_DIR} "${PROJECT_SOURCE_DIR}/src")
    add_definitions("-DTEST_SRC_ROOT=${PROJECT_SOURCE_DIR}/test")
    enable_testing()
    file(GLOB SRC_TEST "${PROJECT_SOURCE_DIR}/test/*.hpp")
    CXXTEST_ADD_TEST(i3ipcpp_check test.cpp ${SRC_TEST})
    target_link_libraries(i3ipcpp_check ${I3IPCPP_LIBRARIES})
  else()
    message(WARNING "CxxTest not found. Unable to run unit-tests")
  endif()
endif()

# }}}

=== lib/i3ipcpp/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(i3ipc++-examples)

include_directories(
	${I3IPCpp_INCLUDE_DIRS}
)

link_directories(
	${I3IPCpp_LIBRARY_DIRS}
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra -Wno-unused-parameter")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g3 -DDEBUG")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O2")

add_executable(workspaces workspaces.cpp)
target_link_libraries(workspaces ${I3IPCpp_LIBRARIES})

add_executable(events events.cpp)
target_link_libraries(events ${I3IPCpp_LIBRARIES})

add_executable(bar-configs bar-configs.cpp)
target_link_libraries(bar-configs ${I3IPCpp_LIBRARIES})

=== debian/changelog ===
polybar (3.7.2-2) unstable; urgency=medium

  * d/p/add_missing_cstdint_includes.patch: New patch to support GCC-15
    (closes: #1097633)

 -- Samuel Henrique <samueloph@debian.org>  Sun, 21 Sep 2025 10:00:15 +0200

polybar (3.7.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 3.7.2
  * d/control: B-D: swap pkg-config for pkgconf

 -- Lucas Gabriel Sousa Camargo Paiva <lucasgabriel_df@hotmail.com>  Thu, 23 Jan 2025 20:30:16 -0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: x11
 Priority: optional
 Homepage: https://polybar.github.io/
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Samuel Henrique <samueloph@debian.org>
+Maintainer: Samuel Henrique <samueloph@debian.org>
 Uploaders: Utkarsh Gupta <utkarsh@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
@@ -28,7 +27,7 @@
                libxcb-util-dev,
                libxcb-xkb-dev,
                libxcb-xrm-dev,
-               pkg-config,
+               pkgconf,
                python3-sphinx,
                python3-xcbgen,
                xcb-proto

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath

ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mips mipsel sh4))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure --		       \
	  -DBUILD_DOC:BOOL="ON"            \
	  -DBUILD_TESTS:BOOL="OFF"         \
	  -DBUILD_DOC_HTML:BOOL="OFF"      \
	  -DBUILD_CONFIG:BOOL="ON"      \
	  -DENABLE_ALSA:BOOL="ON"          \
	  -DENABLE_PULSEAUDIO:BOOL="ON"    \
	  -DENABLE_I3:BOOL="ON"            \
	  -DENABLE_MPD:BOOL="ON"           \
	  -DENABLE_NETWORK:BOOL="ON"       \
	  -DENABLE_CURL:BOOL="ON"          \
	  -DBUILD_IPC_MSG:BOOL="ON"

override_dh_compress:
	dh_compress --exclude=config

=== debian/watch ===
version=4
https://github.com/polybar/polybar/releases .*/polybar-?(\d\S+)\.tar.gz
